/**
	First implementatios of Turtle Graphics
	turtle v. 0.0

	Fraga 12/09/2000
**/
#include <qpainter.h>
#include "turtle.h"

Turtle::Turtle( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
    setPalette( QPalette( QColor( 250, 250, 200) ) );
    setMouseTracking( TRUE );

	ang=0.0; penst=1;
}

void Turtle::Linetest ( int x1, int y1, int x2, int y2 )
{
	int x;
	double dy = y2 - y1;
	double dx = x2 - x1;
	double m = dy/dx;
	double y = y1;

	if ( !penst ) {   // pen is up
		xact = x2;
		yact = y2;
	}
	else { 
		QPainter paint( this );
		// paint.setPen( black );	
		for ( x=x1; x<=x2; x++ ) {
			paint.drawPoint ( x, (int)(y+0.5) );
			y += m;
		}
	}
}

void Turtle::mouseMoveEvent( QMouseEvent * e )
{
	QPoint c = e->pos( );

	xmouse = c.x( );
	ymouse = c.y( );
	if ( xmouse>=0 && ymouse>=0 )  emit changePos ( );
}

//
// This method puts the initial coordinates each time window is resized
//
void Turtle::resizeEvent( QResizeEvent * )
{
	w = width( );
	h = height( );

	xini = w/2;
	yini = h/2;

	emit changeSize ( );
}

QSizePolicy Turtle::sizePolicy() const
{
	return QSizePolicy( QSizePolicy::Expanding, QSizePolicy::Expanding );
}

// Here we must to include our program :

void Turtle::paintEvent( QPaintEvent * )
{
	Linetest( 50, 300, 300, 200 );
}
