/**
  Definition of TURTLE GRAPHICS
  
  Fraga 12/09/2000
**/

#ifndef TURTLE_H
#define TURTLE_H

#include <qwidget.h>


class Turtle: public QWidget
{
	Q_OBJECT
public:
	Turtle( QWidget *parent=0, const char *name=0 );

	void Linetest( int x1, int y1, int x2, int y2 );
	void PenUp ( void ) { penst=0;}
	void PenDown ( void ) { penst=1;}

	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *width, int *height ) { *width = w; *height = h; }
	QSizePolicy sizePolicy() const;

public slots:
	void clearscreen( void ) { 
		erase( ); xact=xini; yact=yini;  
		ang=0.0; penst=1;
	}
	void redraw( void ) { repaint( ); } // Call to paintEvent( )

signals:
    void changePos( ); // called when mouse in moved
    void changeSize( ); // called when windows is resized

protected:
	void paintEvent( QPaintEvent * );
	void mouseMoveEvent( QMouseEvent * );
	void resizeEvent( QResizeEvent * );

private:
	int w, h;        // canvas width and height 
	int xini, yini;  // Initial coordinates (the origin)
	int xact, yact;  // Actual turtle position 
    double ang;		 // Turtle angle
	int penst;       // Pen state: 1 = dowm, 0 = up

	int xmouse, ymouse;  // Mouse pointer coordinates
};


#endif // TURTLE_H
